#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum TemporalUnit {
    #[serde(rename = "HOURS")]
    Hours,
    #[serde(rename = "DAYS")]
    Days,
    #[serde(rename = "WEEKS")]
    Weeks,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl TemporalUnit {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            TemporalUnit::Hours => "HOURS",
            TemporalUnit::Days => "DAYS",
            TemporalUnit::Weeks => "WEEKS",
            TemporalUnit::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for TemporalUnit {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for TemporalUnit {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for TemporalUnit {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(v: &str) -> Result<TemporalUnit, conjure_object::plain::ParseEnumError> {
        match v {
            "HOURS" => Ok(TemporalUnit::Hours),
            "DAYS" => Ok(TemporalUnit::Days),
            "WEEKS" => Ok(TemporalUnit::Weeks),
            v => v.parse().map(|v| TemporalUnit::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for TemporalUnit {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<TemporalUnit, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the TemporalUnit enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
